Package ru.bitel.bgbilling.kernel.contract.api.server.bean

# Class ContractTariffDao

java.lang.Object
ru.bitel.bgbilling.kernel.base.server.logger.BGLogger
ru.bitel.bgbilling.common.dao.AbstarctDaoConstant
ru.bitel.bgbilling.common.dao.AbstractDao<B>
ru.bitel.bgbilling.common.dao.AbstractIdDao<ContractTariff>
ru.bitel.bgbilling.kernel.contract.api.server.bean.ContractTariffDao

public class ContractTariffDao extends ru.bitel.bgbilling.common.dao.AbstractIdDao<ContractTariff>

- ## Field Summary

  ### Fields inherited from class ru.bitel.bgbilling.common.dao.AbstractDao

  `orderByPattern`

  ### Fields inherited from class ru.bitel.bgbilling.common.dao.AbstarctDaoConstant

  `con, ERROR, fields, moduleId, SQL_ALL, SQL_AND, SQL_CALC_FOUND_ROWS, SQL_DELETE, SQL_DISTINCT, SQL_EQ, SQL_EQCS, SQL_FROM, SQL_GROUP, SQL_IN, SQL_INSERT, SQL_JOIN, SQL_LEFT_JOIN, SQL_LIMIT, SQL_NOT_IN, SQL_ON, SQL_ON_DUPLICATE_KEY_UPDATE, SQL_ORDER, SQL_SELECT, SQL_SET, SQL_UPDATE, SQL_VALUES, SQL_WHERE, tableName`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ContractTariffDao(Connection con)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `checkDoubleTariffForContract(int contractId, int tpid, LocalDate date1, LocalDate date2)`
  `int`
  `delete(int id)`
  `void`
  `deleteContractTariffs(int contractId)`
  `void`
  `deleteContractTariffVar(ContractTariffVar contractTariffVar)`
  `ContractTariffVar`
  `getContractTariffVar(int contractTariffId, int tariffVarId)`
  `List<ContractTariffVar>`
  `getContractTariffVars(int contractTariffId)`
  Возвращает список тарифных переменных (тарифных и глобальных) если по contractTariffId найден ContractTariff из него берем ID тарифного плана и возвращаем только глобальные переменные и переменные данного тарифа так же если найден ContractTariff то дополнительно подгужаем переопределение переменных из тарифа иначе только дефолтные занчения переменных
  `ContractTariff`
  `getFirst(int contractId, LocalDate date)`
  Возвращает первый тариф из списка тарифов для договора на определенную дату
  `protected ContractTariff`
  `getFromRS(ResultSet rs)`
  `List<ContractTariff>`
  `list(int contractId, LocalDate date)`
  Возвращает список тарифов для данного договора на определенную дату
  `List<ContractTariff>`
  `list(int contractId, LocalDate date, int emid, int eid)`
  Возвращает список тарифов для данного договора на определенную дату
  `void`
  `updateContractTariffVar(ContractTariffVar contractTariffVar)`
  `protected void`
  `updateImpl(ContractTariff contractTariff)`

  ### Methods inherited from class ru.bitel.bgbilling.common.dao.AbstractIdDao

  `executeUpdate, get, getAndDelete, getAndUpdate, opt, prepareStatement, sqlCommand, sqlCommandAndTable, sqlQuery, sqlWhereId`

  ### Methods inherited from class ru.bitel.bgbilling.common.dao.AbstractDao

  `delete, deleteImpl, eq, get, getById, getImpl, getListFromRS, getPeriod, getQueryById, getSQLOrder, list, list, listImpl, listImpl, listImplPS, listImplPS, ormFromResultSet, ormUpdateImpl, ormUpdateImpl, ormUpdateImpl, ormUpdateImpl, psSetPeriod, queryPeriod, setStatementParam, update`

  ### Methods inherited from class ru.bitel.bgbilling.common.dao.AbstarctDaoConstant

  `getSQLOrder, getTableName, sqlLimit`

  ### Methods inherited from class ru.bitel.bgbilling.kernel.base.server.logger.BGLogger

  `error, error, error, getLogger, logError, logError`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ContractTariffDao

    public ContractTariffDao(Connection con)

- ## Method Details

  - ### getFromRS

    protected ContractTariff getFromRS(ResultSet rs) throws SQLException
    Specified by:
      `getFromRS` in class `ru.bitel.bgbilling.common.dao.AbstractDao<ContractTariff>`
    Throws:
      `SQLException`

  - ### updateImpl

    protected void updateImpl(ContractTariff contractTariff) throws SQLException
    Specified by:
      `updateImpl` in class `ru.bitel.bgbilling.common.dao.AbstractDao<ContractTariff>`
    Throws:
      `SQLException`

  - ### list

    public List<ContractTariff> list(int contractId, LocalDate date) throws SQLException
    Возвращает список тарифов для данного договора на определенную дату
    Parameters:
      `contractId` - код договора
      `date` - дата
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `SQLException`

  - ### list

    public List<ContractTariff> list(int contractId, LocalDate date, int emid, int eid) throws SQLException
    Возвращает список тарифов для данного договора на определенную дату
    Parameters:
      `contractId` - код договора
      `date` - дата
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `SQLException`

  - ### getFirst

    public ContractTariff getFirst(int contractId, LocalDate date) throws SQLException
    Возвращает первый тариф из списка тарифов для договора на определенную дату
    Parameters:
      `contractId` - код договора
      `date` - дата
    Returns:
      null - если нету
    Throws:
      `SQLException`

  - ### delete

    public int delete(int id) throws SQLException
    Overrides:
      `delete` in class `ru.bitel.bgbilling.common.dao.AbstractIdDao<ContractTariff>`
    Throws:
      `SQLException`

  - ### checkDoubleTariffForContract

    public boolean checkDoubleTariffForContract(int contractId, int tpid, LocalDate date1, LocalDate date2) throws SQLException
    Throws:
      `SQLException`

  - ### getContractTariffVars

    public List<ContractTariffVar> getContractTariffVars(int contractTariffId) throws SQLException
    Возвращает список тарифных переменных (тарифных и глобальных) если по contractTariffId найден ContractTariff из него берем ID тарифного плана и возвращаем только глобальные переменные и переменные данного тарифа так же если найден ContractTariff то дополнительно подгужаем переопределение переменных из тарифа иначе только дефолтные занчения переменных
    Parameters:
      `contractTariffId` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `SQLException`

  - ### getContractTariffVar

    public ContractTariffVar getContractTariffVar(int contractTariffId, int tariffVarId) throws SQLException
    Throws:
      `SQLException`

  - ### updateContractTariffVar

    public void updateContractTariffVar(ContractTariffVar contractTariffVar) throws SQLException
    Throws:
      `SQLException`

  - ### deleteContractTariffVar

    public void deleteContractTariffVar(ContractTariffVar contractTariffVar) throws SQLException
    Throws:
      `SQLException`

  - ### deleteContractTariffs

    public void deleteContractTariffs(int contractId) throws SQLException
    Throws:
      `SQLException`